
package de.ivu.elect.presentation.ergebnis.exchange;

import java.util.List;

import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.datei.entity.DateiImportBerichtCustomData;
import de.ivu.elect.business.ergebnis.boundary.ErgebnisDateiQuelle;
import de.ivu.elect.business.ergebnis.boundary.SitzeImporter;
import de.ivu.elect.business.ergebnis.control.SitzeImportContext;
import de.ivu.elect.business.ergebnis.entity.Ergebnisart;
import de.ivu.elect.business.ergebnis.entity.Sitze;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.presentation.View;
import de.ivu.elect.presentation.exchange.AbstractImportSearchView;
import de.ivu.elect.presentation.exchange.ImportDescription;

@Named(SitzeImportSearchView.COMPONENT_NAME)
@View(viewId = SitzeImportSearchView.VIEW_ID, useCase = UseCasePermission.SITZE_IMPORTIEREN)
public class SitzeImportSearchView extends AbstractImportSearchView<List<Sitze>, SitzeImportContext> {

  public static final String COMPONENT_NAME = "sitzeImportSearchView";

  public static final String VIEW_ID = "/ergebnis/sitze-import-search.xhtml";

  @Inject
  private transient SitzeImporter sitzeImporter;

  @Inject
  private transient SitzeImportDescription sitzeImportDescription;

  public SitzeImportSearchView() {
    super();
  }

  @Override
  public boolean isUploadPossible() {
    return super.isUploadPossible() && isWahlMitSitzenSelected();
  }

  private boolean isWahlMitSitzenSelected() {
    return isWahlSelected() && getSelectedWahl().isWahlMitKandidaturen();
  }

  @Override
  protected ImportDescription getImportDescription() {
    return sitzeImportDescription;
  }

  @Override
  protected SitzeImporter getImporter() {
    return sitzeImporter;
  }

  @Override
  protected SitzeImportContext getContext() {
    return new SitzeImportContext(getSelectedWahl(), ErgebnisDateiQuelle.EINGABEWERTE, Ergebnisart.ENDGUELTIG);
  }

  @Override
  protected DateiImportBerichtCustomData createNewDateiImportBerichtCustomData() {
    return new DateiImportBerichtCustomData();
  }
}
